"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.RuleX = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), enums_1 = require("./enums");

class RuleX extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.ruleX, id);
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.rule;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = {
            x: markEncoder.x,
            x1: markEncoder.x,
            y: (datum, el, params) => 0,
            y1: (datum, el, params) => params.viewBox.height()
        };
        return markEncoder.color || markEncoder.group ? res.stroke = null !== (_a = markEncoder.color) && void 0 !== _a ? _a : markEncoder.group : res.stroke = null !== (_c = null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.stroke) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0], 
        res;
    }
}

exports.RuleX = RuleX, RuleX.type = enums_1.PlotMakType.ruleX;
//# sourceMappingURL=rule-x.js.map