"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.RuleY = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), enums_1 = require("./enums"), vutils_1 = require("@visactor/vutils");

class RuleY extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.ruleY, id);
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.rule;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d, _e, _f;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = {
            y: markEncoder.y,
            y1: markEncoder.y,
            x: (0, vutils_1.isArray)(null === (_a = markEncoder.x) || void 0 === _a ? void 0 : _a.field) ? {
                field: markEncoder.x.field[0],
                scale: markEncoder.x.scale
            } : (datum, el, params) => 0,
            x1: (0, vutils_1.isArray)(null === (_b = markEncoder.x) || void 0 === _b ? void 0 : _b.field) ? {
                field: markEncoder.x.field[1],
                scale: markEncoder.x.scale
            } : (datum, el, params) => params.viewBox.width()
        };
        return markEncoder.color || markEncoder.group ? res.stroke = null !== (_c = markEncoder.color) && void 0 !== _c ? _c : markEncoder.group : res.stroke = null !== (_e = null === (_d = this.spec.style) || void 0 === _d ? void 0 : _d.stroke) && void 0 !== _e ? _e : null === (_f = this.getPalette()) || void 0 === _f ? void 0 : _f[0], 
        res;
    }
}

exports.RuleY = RuleY, RuleY.type = enums_1.PlotMakType.ruleY;